
#ifndef __NR_H__
#define __NR_H__
//=============================================================================
#include <iostream.h>

typedef int (*MULTI_FUN)( double* x, double* f, int N );

void fdjac( int n, double x[], double fvec[], double **df,
	    //void (*vecfunc)(int, double [], double [] ) 
	    MULTI_FUN vecfunc
	    );

double fmin( double x[] );

void lnsrch( int n, double xold[], double fold, double g[], 
	     double p[], double x[], double *f, double stpmax, 
	     int *check, 
	     double (*func)(double []) 
	     );

void qrdcmp( double **a, int n, double c[], double d[],  int  *sing );
void qrsolv( double **a, int n, double c[], double d[], double b[] );
void  rsolv( double **a, int n, double d[], double b[] );

void qrupdt( double **r, double **qt, int n, double *u,  double v[] );

void broydn( double *x,
	     MULTI_FUN vecfunc,
	     const int& n,
	     const double& eps,
	     int* check
	     );
//=============================================================================
#endif // __NR_H__
