
#ifndef __NR_H__
#define __NR_H__

void rsolv(double **a, int n, double d[], double b[]);
void rotate(double **r, double **qt, int n, int i, double a, double b);
void qrupdt(double **r, double **qt, int n, double u[], double v[]);
void qrsolv(double **a, int n, double c[], double d[], double b[]);
void qrdcmp(double **a, int n, double *c, double *d, int *sing);
void lnsrch(int n, double xold[], double fold, 
	    double g[], double p[], double x[],
	    double *f, double stpmax, int *check, double (*func)(double []));
double fmin(double x[]);
void fdjac(int n, double x[], double fvec[], double **df,
	   int (*vecfunc)(double [], double [], int));
void broydn(double x[], 
	    int (*vecfunc)(double [], double [], int),
	    int n, 
	    double tolerance,
	    int *check
	    );


#endif // __NR_H__
