#ifndef __QN_H__
#define __QN_H__

#include <math.h>
#include <stdio.h>
#include "IOP.h"
//=========================================================================
typedef int (*MULTI_FUN  )( double* &x, double* &f, const int &N );
//-------------------------------------------------------------------------
int quasi_Newton_method( double*      &x, 
			 double*      &f, 
			 double**     &H, 
			 MULTI_FUN     fun,
			 const int    &N, 
			 const double &eps );

//=========================================================================
//-------------------------------------------------------------------------
typedef int (*MULTI_FUN_2)( IOParameterSet &params,
			    double*         &x,
			    double*         &f );
//-------------------------------------------------------------------------
typedef int (*JACOBI_FUN_2)( IOParameterSet &params,
			     double*        &x0,
			     MULTI_FUN_2     func,
			     double**       &J
			   );
//-------------------------------------------------------------------------
int quasi_Newton_method_2( IOParameterSet &params,
			   double*        &x, 
			   MULTI_FUN_2     func
			   );
//=========================================================================
inline int delta(const int& i,const int &j){if(i==j){return(1);} return(0);}
//=========================================================================
int Jacobi_Matrix_2( IOParameterSet &params,
		     double*       &x0,
		     MULTI_FUN_2    func,
		     double**      &J
		     );

#endif//__QN_H__
