#include <math.h>
#include "Gauss.h"
#include "QuasiNewton.h"

//=========================================================================
//typedef int (*MULTI_FUN  )( double* &x, double* &f, const int &N );

int Jacobi_Matrix( double*   &xo, 
		   double**  &J, 
		   MULTI_FUN  fun, 
		   const int &N );

int multi_fun (   double* &x, double* &f, const int &N );
int Write_Result( double* &x, double* &f, const int &N, const double &eps );
//=========================================================================
int main()
{
  int N=2; 
  double eps=1.0e-10;
  double *x, *f, **H;
  x =new double[N];
  f =new double[N];
  H = new double* [N];
  H[0] = new double[N];
  H[1] = new double[N];
  
  x[0]=0.814098, x[1]=1.2093;
  //=======================================
  Jacobi_Matrix( x, H, multi_fun, N );

  GJE0( H, N );

  multi_fun( x, f, N );
  quasi_Newton_method( x, f, H, multi_fun, N, eps );
  //=======================================

  Write_Result( x, f, N, eps );

  return(0);
}
//=========================================================================
int multi_fun (   double* &x, double* &f, const int &N )
{
	double u = 2.013;
  f[0] = 
		+ ( log( x[0] ) - u*x[0] + 0.5*x[0]*x[0] )
		- ( log( x[1] ) - u*x[1] + 0.5*x[1]*x[1] );

  f[1] = 
		+ ( x[0] - 0.5*x[0]*x[0] + 1.0/3.0 *x[0]*x[0]*x[0] )
		- ( x[1] - 0.5*x[1]*x[1] + 1.0/3.0 *x[1]*x[1]*x[1] );

  return( 0 );
}
//=========================================================================
int Jacobi_Matrix( double* &x, double** &J, MULTI_FUN fun, const int &N )
{
	double u = 2.013;
  // J[i][j] // i: runs for functions, j: runs for variables
	J[0][0] = + ( 1.0/x[0] - u + x[0] );
	J[0][1] =	- ( 1.0/x[1] - u + x[1] );
	J[1][0] = +( 1.0 - x[0] + x[0]*x[0] );
	J[1][1] = -( 1.0 - x[1] + x[1]*x[1] );
  return(0);
}
//=========================================================================
int Write_Result( double* &x, double* &f, const int &N, const double &eps )
{
  int i,j;
  printf("\n***********************\n");
  for( j=0; j<N; j++ ){
    printf("x[%d]=%17.17e ",j,x[j] );
  }
  printf("\n");
  for( j=0; j<N; j++ ){
    printf("F[%d]=%17.17e ",j,f[j] );
  }
  printf("\n***********************\n");
  printf("This is solution ! for eps = %e", eps );
  printf("\n");
  return(0);
}
//=========================================================================
