#include <math.h>
#include "Gauss.h"
#include "QuasiNewton.h"
#define CHI 3.0
//=========================================================================
//typedef int (*MULTI_FUN  )( double* &x, double* &f, const int &N );

int Jacobi_Matrix( double* xo, 
		   double ** J, 
		   MULTI_FUN fun, 
		   int N );

int multi_fun (   double* &x, double* &f, const int &N );
int Write_Result( double* &x, double* &f, const int &N, const double &eps );
//=========================================================================
int main()
{
  int N=2; double eps=1.0e-13;
  double *x, *f, **H;
  x = new double  [N];
  f = new double  [N];
  H = new double* [N];
  H[0] = new double[N];
  H[1] = new double[N];
  
  x[0]=0.40, x[1]=0.6;
  //=======================================
  Jacobi_Matrix( x, H, multi_fun, N );
  GJE0( H, N );
  multi_fun( x, f, N );
  quasi_Newton_method( x, f, H, multi_fun, N, eps );
  //=======================================
  Write_Result( x, f, N, eps );

  return(0);
}
//=========================================================================
int multi_fun (   double* &x, double* &f, const int &N )
{
  f[0] = x[0]*x[0] + x[1]*x[1] -5.0;
  f[1] = x[0]+2.0*x[1];
  return( 0 );
}
//=========================================================================
int Jacobi_Matrix( double* x, double** J, MULTI_FUN fun, int N )
{
  // J[i][j] // i: runs for functions, j: runs for variables
  // J00= df0/dx0
  // J01= df0/dx1
  // J10= df1/dx0
  // J11= df1/dx1
  J[0][0] = + 2*x[0];
  J[0][1] = + 2*x[1];
  J[1][0] = 1;
  J[1][1] = 2;
  return(0);
}
//=========================================================================
int Write_Result( double* &x, double* &f, const int &N, const double &eps )
{
  int i,j;
  printf("\n***********************\n");
  for( j=0; j<N; j++ ){
    printf("x[%d]=%17.17e ",j,x[j] );
  }
  printf("\n");
  for( j=0; j<N; j++ ){
    printf("F[%d]=%17.17e ",j,f[j] );
  }
  printf("\n***********************\n");
  printf("This is solution ! for eps = %e", eps );
  printf("\n");
  return(0);
}
//=========================================================================
