
#include "QuasiNewton_ver1.h"

//=========================================================================
int quasi_Newton_method( double* x, 
			 double* f,
			 double **H, 
			 MULTI_FUN fun,
			 int N, 
			 double eps )
{
  int i,j, flag=1;
  double *q  = new double[N];
  double *p  = new double[N];
  double *dx = new double[N];
  double inv_ss_sHF, ss=0.0, sHF=0.0;

  while(1){

    ///////////////////////////    
    // Convergence Criterion //
    double max = 0.0e0;
    for( j=0; j<N; j++ ){ 
      if( fabs(f[j]) > max ){ max = fabs(f[j]); }
    }
    printf( "max=%e\n",max);
    if( max < eps ){ printf( "max=%e\n",max);
      flag=0;
      break; 
    }
    ///////////////////////////

    for( j=0; j<N; j++ ){ 
      dx[j] = 0.0;
      for( i=0; i<N; i++ ){ dx[j] -= H[j][i]*f[i]; }
    }

    for( j=0; j<N; j++ ){ x[j] += dx[j]; }


    fun( x, f, N );
    double ss = 0.0, sHF = 0.0 ;
    for( i=0; i<N; i++ ){ 
      ss += dx[i]*dx[i];
      q[i] = 0.0; p[i] = 0.0;
      for( j=0; j<N; j++ ){
	q[i] +=       H[i][j]*f[j];
	p[i] += dx[j]*H[j][i];
	sHF  += dx[i]*H[i][j]*f[j];
      }
    }
    double inv__ss_plus_sHF = 1.0/(ss+sHF);
    for( j=0; j<N; j++ ){ 
      for( i=0; i<N; i++ ){ H[i][j] -= q[i]*p[j] * inv__ss_plus_sHF; }
    }
  }

  delete [] q; 
  delete [] p;   
  delete [] dx;
  return(flag);
}
//=========================================================================

