
#include "multi_qnm.h"

//=========================================================================
int main(int argc, char** argv )
{
  try{
    IOParameterSet params(argv[1]);
    double *x;
    Allocation( params, x ); x[0] = 0.1; x[1] = 2.5;
    quasi_Newton_method( params, x, multi_func, Jacobi_Matrix );
  }
  catch (MotherErr& a){ cout << a.Get() << endl ; exit (1); }
  catch (...){  cout << "unknown err!!" << endl ; exit (1); }

  return(0);
}
//=========================================================================
int multi_func( IOParameterSet& params, double* x, double* f, const int &N )
{
  f[0] = x[0]*x[0] + x[1]*x[1] -5.0;
  f[1] = x[0]+2.0*x[1];
  return( 0 );
}
//=========================================================================
int Allocation( IOParameterSet& params, double*  &x )
{
  static int N = params.int_value("QUASI_NEWTON:N");

  ALLOC_1D( x, N );
  return(0);
}
//=========================================================================
