#include <math.h>
#include <iostream.h>
double fun( double x );
typedef double (*FUN)(double x);

double f_prime( double x, FUN );
double quasi_Newton_method( double x0, FUN, double (*)( double, FUN ) );
//=========================================================================
int main()
{
  double x0 = 1.0;
  double x = quasi_Newton_method( x0, fun, f_prime );
  cout << x << endl;
}
//=========================================================================
double quasi_Newton_method( double x0, FUN f, double (*f_prime)( double,FUN ) )
{
  double grad_f = f_prime(x0, f);
  double eps = 1.0e-5;
  static double sqrt2 = sqrt(2.0e0);
  while(1){
    x0 -= f(x0)/grad_f;
    grad_f += x0*x0;
    cout.precision(15);
    cout << "d x0=" << x0 - sqrt2 << " grad f=" << grad_f << endl;
  }
}
//=========================================================================
double fun( double x )
{
  double f = x*x-2.0e0;
  return( f );
}
//=========================================================================
double f_prime( double x, FUN fun )
{
  double dx = 1.0e-2;
  double inv_dx  = 1.0/dx;
  double f0 = fun( x );
  double f1 = fun( x + dx );
  return( (f1-f0)*inv_dx );

}
//=========================================================================
