
#ifndef  __MULTI_QNM_H__
#define  __MULTI_QNM_H__

#include <math.h>
#include <iostream>
#include <fstream>
#include "Gauss.h"
#include "ALLOC.h"
#include "IOP.h"

//=========================================================================
typedef int (*MULTI_FUN)( IOParameterSet& params, double* x,
			  double* f, const int &N );

typedef int (*JACOBI_FUN)( IOParameterSet& params,
			   double* x0,
			   MULTI_FUN func,
			   double **J,
			   const int &N
			   );

int multi_func( IOParameterSet& params, double* x,
		double* f, const int &N );


//=========================================================================
int Jacobi_Matrix(
		  IOParameterSet& params,
		   double* x0,
		   MULTI_FUN func,
		   double **J,
		   const int &N
		  );
//=========================================================================
int quasi_Newton_method( IOParameterSet& params,
			 double*   &x, 
			 MULTI_FUN     Multi_func, 
			 JACOBI_FUN    J_func
			 );
//=========================================================================
inline int delta( const int& i, const int &j )
{
  if( i==j ){ return(1); } return(0);
}
//=========================================================================
int Allocation( IOParameterSet& params, double*  &x );
  //=========================================================================
#endif //__MULTI_QNM_H__
